#include <Arduino.h>
#include <BLEDevice.h>
#include <BLEServer.h>

#define SERVICE_UUID "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
#define CHARACTERISTIC_UUID "beb5483e-36e1-4688-b7f5-ea07361b26a8"

class BluetoothService {
	const char *_serviceName;
	BLECharacteristicCallbacks *_callbacks;
	BLEServer *_server;
	BLEService *_service;
	BLECharacteristic *_characteristic;

public:
	BluetoothService(const char* serviceName, BLECharacteristicCallbacks* callbacks) {
		_serviceName = serviceName;
		_callbacks = callbacks;
	}

	void init() {
		BLEDevice::init(_serviceName);
		_server = BLEDevice::createServer();
		_service = _server->createService(SERVICE_UUID);
		_characteristic = _service->createCharacteristic(CHARACTERISTIC_UUID, BLECharacteristic::PROPERTY_READ | BLECharacteristic::PROPERTY_WRITE);
		_characteristic->setCallbacks(_callbacks);
	}

	void start() {
		_service->start();
		_server->getAdvertising()->start();
	}
};
